-- Common imports.
import "Turbine";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Gameplay";
import "Turbine.Animation";
import "Turbine.UI.Extensions";


-- comment the load
Turbine.Shell.WriteLine("Vitalbar loaded")

-- get resolution
screenWidth, screenHeight = Turbine.UI.Display:GetSize();

-- constant window
local width = 500
local height = 40
--local opacity = 0.2
local heightfromground = 200


Background = "ROCKsPlugins/HelloWorld/Resources/Verlauf.tga"

-- actor vitalbar
window = Turbine.UI.Window();
window:SetPosition(screenWidth/2 - width/2, screenHeight - height - heightfromground);
window:SetSize(width, height);
window:SetVisible(true);
window:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));
window:SetZOrder(-1);
window:SetBackground(Background);
window:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply);


--window.MouseDown = function(sender, args)
--    Turbine.Shell.WriteLine("MouseDown");
--end
--
--
--window.MouseUp = function(sender, args)
--    Turbine.Shell.WriteLine("MouseUp");
--end

--function newFont (control, text, position, opacity)
--    control = Turbine.UI.Label();
--    control:SetParent(window);
--    control:SetSize(width, height);
--    control:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
--    control:SetOutlineColor(Turbine.UI.Color(opacity, 0, 0, 0));
--    control:SetFontStyle(Turbine.UI.FontStyle.Outline);
--    control:SetFont(Turbine.UI.Lotro.Font.Verdana20);
--    control:SetTextAlignment(position);
--    control:SetText(text);
--end
--
--function newFont2 (control, text, position, opacity)
--    control = Turbine.UI.Label();
--    control:SetParent(window);
--    control:SetSize(width, height);
--    control:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
--    control:SetOutlineColor(Turbine.UI.Color(opacity, 0, 0, 0));
--    control:SetFontStyle(Turbine.UI.FontStyle.Outline);
--    control:SetFont(Turbine.UI.Lotro.Font.Verdana20);
--    control:SetTextAlignment(position);
--    control:SetText(text);
--end
--
--
---- morale label
--label1 = Turbine.UI.Label();
--label1:SetParent(window);
--label1:SetSize(width, height);
--label1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
--label1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
--label1:SetOutlineColor(Turbine.UI.Color(opacity, 0, 0, 0));
--label1:SetFontStyle( Turbine.UI.FontStyle.Outline )
--label1:SetFont( Turbine.UI.Lotro.Font.Verdana20 )
--
--
---- percent label
--label2 = Turbine.UI.Label()
--label2:SetParent(window);
--label2:SetSize(width, height);
--label2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
--label2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
--label2:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));
--
--
---- + label
--label3 = Turbine.UI.Label()
--label3:SetParent(window);
--label3:SetSize(width, height);
--label3:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
--label3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
--label3:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));
--label3:SetFontStyle( Turbine.UI.FontStyle.Outline )
--label3:SetFont( Turbine.UI.Lotro.Font.Verdana16 )
--
--
---- morale change label
--label4 = Turbine.UI.Label()
--label4:SetParent(window);
--label4:SetVisible(false);
--label4:SetSize(width, height);
--label4:SetBackColor(Turbine.UI.Color(1, 1, 0, 0));
--label4:SetZOrder(-1);
--
--
---- hit label, delta between two hits
--WidthLast = width;
--
--label5 = Turbine.UI.Label()
--label5:SetParent(window);
--label5:SetVisible(false);
--label5:SetSize(WidthLast, height);
--label5:SetBackColor(Turbine.UI.Color(1, 1, 1, 1));
--label5:SetZOrder(-2);
--
--
--player = Turbine.Gameplay.LocalPlayer.GetInstance()
--MaxMorale = player:GetMaxMorale();
--MaxMoraleRound = math.floor (MaxMorale);
--
--
--
--startTime = 0;
--
--player.MoraleChanged = function (sender, args)
--    label4:SetVisible(true); -- visible
--    label5:SetVisible(true); -- visible
--    
--    -- opaticity change from text labels
--    label1:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
--    label2:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
--    label3:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
--
--    window:SetBackColor(Turbine.UI.Color(1, 0, 0, 0));
--
--   
--    -- get actualy morale
--    local MoraleChange = player:GetMorale();
--    MoraleChangeRound = math.floor (MoraleChange);
--    label1:SetText(MoraleChangeRound .. " / " .. MaxMoraleRound);
--    local PercentMorale = (MoraleChangeRound / MaxMoraleRound * 100);
--    local PercentMoraleRound = math.floor (PercentMorale);
--    label2:SetText(PercentMoraleRound .. " % ");
--
--
--    
--  
--    -- width change for label
--        -- 100 % = width (max 500)
--        -- 0 % = width (min 0)
--    local WidthChange = width * PercentMoraleRound / 100;
--
--
--    -- morale change label continue
--    label4:SetSize(WidthChange, height);
--
--    -- width change for morale between two hits
--    label5:SetSize(WidthLast, height);
--    local WidthDelta = WidthLast - WidthChange;
--    WidthLast = WidthLast - WidthDelta;
--
--
--    if (WidthDelta < 0)
--        then
--            WidthDelta = 0;
--    end
--        
--
--    -- time
--    local currentTime = Turbine.Engine.GetGameTime(); -- in seconds
--    local currentTimeRound = math.floor (currentTime);
--    if (startTime > currentTimeRound) then
--        -- Reduce the hit label width
--        repeat
--            WidthDelta = WidthDelta - 1;
--            label5:SetSize((WidthLast + WidthDelta), height);
--            until (WidthDelta == 0)
--    end   
--    startTime = currentTimeRound + 0,1;
--
--    
--    -- end fight, return to start view 
--    if player:IsInCombat() == false and PercentMoraleRound == 100 then
--        label4:SetVisible(false); -- unvisible
--        label5:SetVisible(false); -- unvisible
--    	label1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
--    	label2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
--    	label3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
--        window:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));
--        label1:SetText(MaxMoraleRound);
--    end
--end
--
---- Start Print
--label1:SetText(MaxMoraleRound);
--label2:SetText("100 % ");
--label3:SetText(" +"); 
--
---- item switch morale update
----player.MaxMoraleChanged = function (sender, args)
----
----    Turbine.Shell.WriteLine("function MaxMoraleChanged")
----    MaxMorale = player:GetMaxMorale();
----    MaxMoraleRound = math.floor (MaxMorale);
----    label1:SetText(MaxMoraleRound);
----    label4:SetVisible(false); -- unvisible
----    label5:SetVisible(false); -- unvisible
----    label2:SetText("100 % ");
----    
----end
--function wait( seconds )
--    local startTime = Turbine.Engine.GetDate(Second); -- in seconds
--    Turbine.Shell.WriteLine(startTime);
--    --repeat
--    --local currentTime = Turbine.Engine.GetGameTime(); -- in seconds
--    --local deltaTime = currentTime - startTime;
--    --until (deltaTime > 1)
--end
--
--i=100
--repeat
--    i = i - 1;
--    --Turbine.Shell.WriteLine(i);
--    wait(1);
--until (i == 0)



--function MaxMoraleUpdate (MaxMorale)
--    local MaxMorale = Player:GetMaxMorale();
--    local Morale = math.floor(Player:GetMorale());
--    local MoralePlot = (Morale .. " / " .. MaxMorale)
--    newFont(labelTest, MoralePlot, Turbine.UI.ContentAlignment.MiddleCenter, 0.2);
--end
--
--function PlotSingleMorale (Morale)
--    local Morale = math.floor(Player:GetMorale());
--    newFont(labelTest, Morale, Turbine.UI.ContentAlignment.MiddleCenter, 0.2);
--end
--
--Player = Turbine.Gameplay.LocalPlayer.GetInstance();
--
--PlotSingleMorale();
--MaxMoraleUpdate();


timerControl = Turbine.UI.Control();

timerControl.expireTime = 15;
timerControl.middleTime = 10;
timerControl.endTime = 5;

    timerControl:SetParent(windows);
    --timerControl.BackColorStart = Turbine.UI.Color.White;
    --timerControl.BackColorMiddle = Turbine.UI.Color.Yellow;
    --timerControl.BackColorEnd = Turbine.UI.Color.Red;
    timerControl.startTime = 0;
    timerControl.previousUpdateTime = 0;
    timerControl.Update = function(sender, args)
        local currentTime = Turbine.Engine.GetGameTime();
        local deltaTime = currentTime - timerControl.startTime;
        local timeLeft = timerControl.expireTime - deltaTime;

        local isPrecise = timeLeft < 5;
        local updateInterval = 0.5;
        --if (isPrecise) then updateInterval = .05; end

        --if (deltaTime > timerControl.expireTime) then
            -- Hide();
        if (currentTime > (timerControl.previousUpdateTime + updateInterval)) then
            timerControl.previousUpdateTime = currentTime;
            local windowWidth = SETTINGS.WINDOW.WIDTH * screenWidth;
            local barWidth = windowWidth - (deltaTime / timerControl.expireTime * windowWidth);
            timerControl:SetWidth(barWidth);

            local precision = 0;
            if (isPrecise) then precision = 1; end

            local timeLeftRounded = string.format("%." .. precision .. "f", timeLeft);
            timerText:SetText(timeLeftRounded);

            if (timeLeft < timerControl.endTime) then
                -- Red / End
                timerControl:SetBackColor(timerControl.BackColorEnd);
            elseif (timeLeft < timerControl.middleTime) then
                -- Yellow / Middle
                timerControl:SetBackColor(timerControl.BackColorMiddle);
            end
        end
    end