-- actor vitalbar
targetWindow = Turbine.UI.window();
targetWindow:SetPosition(screenWidth/2 - width/2, screenHeight - height - heightfromgroundTarget);
targetWindow:SetSize(width, height);
targetWindow:SetVisible(true);
targetWindow:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));
targetWindow:SetZOrder(-1);
targetWindow:SetBackground(Background);
targetWindow:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply );


-- morale label
labelTarget1 = Turbine.UI.Label();
labelTarget1:SetParent(targetWindow);
labelTarget1:SetSize(width, height);
labelTarget1:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
labelTarget1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
labelTarget1:SetOutlineColor(Turbine.UI.Color(opacity, 0, 0, 0));
labelTarget1:SetFontStyle( Turbine.UI.FontStyle.Outline )
labelTarget1:SetFont( Turbine.UI.Lotro.Font.Verdana20 )


-- percent label
labelTarget2 = Turbine.UI.Label()
labelTarget2:SetParent(targetWindow);
labelTarget2:SetSize(width, height);
labelTarget2:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleRight );
labelTarget2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
labelTarget2:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));


-- + label
labelTarget3 = Turbine.UI.Label()
labelTarget3:SetParent(targetWindow);
labelTarget3:SetSize(width, height);
labelTarget3:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
labelTarget3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
labelTarget3:SetOutlineColor(Turbine.UI.Color(1, 0, 0, 0));
labelTarget3:SetFontStyle( Turbine.UI.FontStyle.Outline )
labelTarget3:SetFont( Turbine.UI.Lotro.Font.Verdana16 )


-- morale change label
labelTarget4 = Turbine.UI.Label()
labelTarget4:SetParent(targetWindow);
labelTarget4:SetVisible(false);
labelTarget4:SetSize(width, height);
labelTarget4:SetBackColor(Turbine.UI.Color(1, 1, 0, 0));
labelTarget4:SetZOrder(-1);
labelTarget4:SetBackground(Background2);
labelTarget4:SetBackColorBlendMode( Turbine.UI.BlendMode.Multiply );


-- hit label, delta between two hits
widthLast = width;

labelTarget5 = Turbine.UI.Label()
labelTarget5:SetParent(targetWindow);
labelTarget5:SetVisible(false);
labelTarget5:SetSize(widthLast, height);
labelTarget5:SetBackColor(Turbine.UI.Color(1, 1, 1, 1));
labelTarget5:SetZOrder(-2);


-- load LocalPlayer
player = Turbine.Gameplay.LocalPlayer.GetInstance()
local maxMorale = math.floor(player:GetMaxMorale());
target = LocalPlayer:GetTarget():
targetMorale = target:GetMorale();
Turbine.Shell.WriteLine(targetMorale);

-- Start Print
labelTarget1:SetText(maxMorale);
labelTarget2:SetText("100 % ");
labelTarget3:SetText(" +"); 


-- routine by max morale change
player.MaxMoraleChanged = function (sender, args)
    -- get actualy morale
    local actuMorale = math.floor(player:GetMorale());

    -- get max. Morale
    local maxMorale = math.floor(player:GetMaxMorale());

    -- Morale in percent
    local percentMorale = math.floor((actuMorale / maxMorale * 100));

    -- display Morale
    if percentMorale == 100 then
        labelTarget1:SetText(maxMorale);
        -- set label visibility
        labelTarget4:SetVisible(false); -- visible
        labelTarget5:SetVisible(false); -- visible
        -- opaticity change from text labels
        labelTarget1:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        labelTarget2:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        labelTarget3:SetForeColor(Turbine.UI.Color(opacity, 1, 1, 1));
        windowTarget:SetBackColor(Turbine.UI.Color(opacity, 0, 0, 0));

    else
        labelTarget1:SetText(actuMorale .. " / " .. maxMorale);
        -- set label visibility
        labelTarget4:SetVisible(true); -- visible
        labelTarget5:SetVisible(true); -- visible
        -- opaticity change from text labels
        labelTarget1:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        labelTarget2:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        labelTarget3:SetForeColor(Turbine.UI.Color(1, 1, 1, 1));
        windowTarget:SetBackColor(Turbine.UI.Color(0.8, 0, 0, 0));
        windowTarget:SetBackColorBlendMode( Turbine.UI.BlendMode.AlphaBlend );
        -- width change for label, morale change label continue, 100 % = width (max 500), 0 % = width (min 0)
        local widthChange = width * percentMorale / 100;
        labelTarget4:SetSize(widthChange, height);
        -- width change for morale between two hits
        labelTarget5:SetSize(widthLast, height);
        local widthDelta = widthLast - widthChange;
        widthLast = widthLast - widthDelta;
    end

    --display percent Morale
    labelTarget2:SetText(percentMorale .. " % ");
 
end